
#ifndef kbd_INCLUDED_
#define kbd_INCLUDED_
#include "tdelay.h"
void kbd_pin(int port,int a1,int a2,int a3,int a4,int b1,int b2,int b3,int b4);
void debounce(unsigned long b);

int row1,row2,row3,row4,getkbd;
int clm1,clm2,clm3,clm4;
int port_add;
void kbd_pin(int port,int a1,int a2,int a3,int a4,int b1,int b2,int b3,int b4)
{

 row1=a1,row2=a2,row3=a3,row4=a4;
 clm1=b1,clm2=b2,clm3=b3,clm4=b4;

 switch (port)
   {
 	case 1:	port_add =0xFFFFF400; // (PIOA) Base Address
		break;
	case 2:	port_add =0xFFFFF600; // (PIOB) Base Address
		break;
	default :	port_add =0xFFFFF600;
		break;
   }
}
unsigned int get_kbd(void){

  getkbd=16;
  AT91F_PIO_CfgOutput (((AT91PS_PIO)port_add),(1<<row1));
  AT91F_PIO_CfgOutput (((AT91PS_PIO)port_add),(1<<row2));
  AT91F_PIO_CfgOutput (((AT91PS_PIO)port_add),(1<<row3));
  AT91F_PIO_CfgOutput (((AT91PS_PIO)port_add),(1<<row4));

  AT91F_PIO_CfgInput (((AT91PS_PIO)port_add),(1<<clm1));
  AT91F_PIO_CfgInput (((AT91PS_PIO)port_add),(1<<clm2));
  AT91F_PIO_CfgInput (((AT91PS_PIO)port_add),(1<<clm3));
  AT91F_PIO_CfgInput (((AT91PS_PIO)port_add),(1<<clm4));

  if (port_add ==0xFFFFF400)
      AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC,1<<AT91C_ID_PIOA);
  else
      AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC,1<<AT91C_ID_PIOB);


  AT91F_PIO_CfgPullup(((AT91PS_PIO)port_add),(1<<clm1));
  AT91F_PIO_CfgPullup(((AT91PS_PIO)port_add),(1<<clm2));
  AT91F_PIO_CfgPullup(((AT91PS_PIO)port_add),(1<<clm3));
  AT91F_PIO_CfgPullup(((AT91PS_PIO)port_add),(1<<clm4)); 
	
  AT91F_PIO_CfgInput (((AT91PS_PIO)port_add),(1<<clm1));
  AT91F_PIO_CfgInput (((AT91PS_PIO)port_add),(1<<clm2));
  AT91F_PIO_CfgInput (((AT91PS_PIO)port_add),(1<<clm3));
  AT91F_PIO_CfgInput (((AT91PS_PIO)port_add),(1<<clm4));


//*************************First Row****************************************
	AT91F_PIO_ClearOutput (((AT91PS_PIO)port_add),(1<<row1));
	AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row2));
	AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row3));
	AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row4));


    if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm1)) == 0)
	 {
        getkbd=0;
        goto x;
	 }

    if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm2)) == 0)
	 {
        getkbd=1;
        goto x;
	 }

    if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm3)) == 0)
	 {
        getkbd=2;
        goto x;	
	 }

   if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm4)) == 0)
    {
        getkbd=3;
        goto x;
	}

    delay_ms(50); 
//*************************************************************************************
//*****************************Second Row****************************************
	AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row1));
    AT91F_PIO_ClearOutput (((AT91PS_PIO)port_add),(1<<row2));
	AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row3));
	AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row4));

   if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm1)) == 0) {
    getkbd=4;
	goto x;}
   if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm2)) == 0) {
    getkbd=5;
	goto x;}
   if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm3)) == 0) {
    getkbd=6;
	goto x;}
   if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm4)) == 0) {
    getkbd=7;
	goto x;	}
   delay_ms(50);     
//*************************************************************************************
//****************************Thirt Row********************************************
	AT91F_PIO_SetOutput (((AT91PS_PIO)port_add),(1<<row1));
	AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row2));
	AT91F_PIO_ClearOutput(((AT91PS_PIO )port_add),(1<<row3));
	AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row4));

  if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm1)) == 0) {
    getkbd=8;
	goto x;}
  if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm2)) == 0) {
    getkbd=9;
	goto x;}
  if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm3)) == 0) {
    getkbd=10;
	goto x;}
  if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm4)) == 0) {
    getkbd=11;
	goto x;}

  delay_ms(50);     
//*************************************************************************************
//***********************************************************************************
   AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row1));
   AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row2));
   AT91F_PIO_SetOutput(((AT91PS_PIO)port_add),(1<<row3));
   AT91F_PIO_ClearOutput(((AT91PS_PIO) port_add),(1<<row4));

 if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm1)) == 0) {
    getkbd=12;
	goto x;}
 if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm2)) == 0) {
    getkbd=13;
	goto x;}
 if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm3)) == 0) {
    getkbd=14;
	goto x;}
 if ((AT91F_PIO_GetInput((AT91PS_PIO)port_add) & (1<<clm4)) == 0) {
    getkbd=15;
	goto x;}

  delay_ms(25);
  x: 



 return(getkbd); 	  
  
 } 
//*********************************************************************

//*********************************************************************

#endif
